"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.de_GetManagedNotificationChildEventCommand = exports.de_GetEventRuleCommand = exports.de_EnableNotificationsAccessForOrganizationCommand = exports.de_DisassociateManagedNotificationAdditionalChannelCommand = exports.de_DisassociateManagedNotificationAccountContactCommand = exports.de_DisassociateChannelCommand = exports.de_DisableNotificationsAccessForOrganizationCommand = exports.de_DeregisterNotificationHubCommand = exports.de_DeleteNotificationConfigurationCommand = exports.de_DeleteEventRuleCommand = exports.de_CreateNotificationConfigurationCommand = exports.de_CreateEventRuleCommand = exports.de_AssociateManagedNotificationAdditionalChannelCommand = exports.de_AssociateManagedNotificationAccountContactCommand = exports.de_AssociateChannelCommand = exports.se_UpdateNotificationConfigurationCommand = exports.se_UpdateEventRuleCommand = exports.se_UntagResourceCommand = exports.se_TagResourceCommand = exports.se_RegisterNotificationHubCommand = exports.se_ListTagsForResourceCommand = exports.se_ListNotificationHubsCommand = exports.se_ListNotificationEventsCommand = exports.se_ListNotificationConfigurationsCommand = exports.se_ListManagedNotificationEventsCommand = exports.se_ListManagedNotificationConfigurationsCommand = exports.se_ListManagedNotificationChildEventsCommand = exports.se_ListManagedNotificationChannelAssociationsCommand = exports.se_ListEventRulesCommand = exports.se_ListChannelsCommand = exports.se_GetNotificationsAccessForOrganizationCommand = exports.se_GetNotificationEventCommand = exports.se_GetNotificationConfigurationCommand = exports.se_GetManagedNotificationEventCommand = exports.se_GetManagedNotificationConfigurationCommand = exports.se_GetManagedNotificationChildEventCommand = exports.se_GetEventRuleCommand = exports.se_EnableNotificationsAccessForOrganizationCommand = exports.se_DisassociateManagedNotificationAdditionalChannelCommand = exports.se_DisassociateManagedNotificationAccountContactCommand = exports.se_DisassociateChannelCommand = exports.se_DisableNotificationsAccessForOrganizationCommand = exports.se_DeregisterNotificationHubCommand = exports.se_DeleteNotificationConfigurationCommand = exports.se_DeleteEventRuleCommand = exports.se_CreateNotificationConfigurationCommand = exports.se_CreateEventRuleCommand = exports.se_AssociateManagedNotificationAdditionalChannelCommand = exports.se_AssociateManagedNotificationAccountContactCommand = exports.se_AssociateChannelCommand = void 0;
exports.de_UpdateNotificationConfigurationCommand = exports.de_UpdateEventRuleCommand = exports.de_UntagResourceCommand = exports.de_TagResourceCommand = exports.de_RegisterNotificationHubCommand = exports.de_ListTagsForResourceCommand = exports.de_ListNotificationHubsCommand = exports.de_ListNotificationEventsCommand = exports.de_ListNotificationConfigurationsCommand = exports.de_ListManagedNotificationEventsCommand = exports.de_ListManagedNotificationConfigurationsCommand = exports.de_ListManagedNotificationChildEventsCommand = exports.de_ListManagedNotificationChannelAssociationsCommand = exports.de_ListEventRulesCommand = exports.de_ListChannelsCommand = exports.de_GetNotificationsAccessForOrganizationCommand = exports.de_GetNotificationEventCommand = exports.de_GetNotificationConfigurationCommand = exports.de_GetManagedNotificationEventCommand = exports.de_GetManagedNotificationConfigurationCommand = void 0;
const core_1 = require("@aws-sdk/core");
const core_2 = require("@smithy/core");
const smithy_client_1 = require("@smithy/smithy-client");
const models_0_1 = require("../models/models_0");
const NotificationsServiceException_1 = require("../models/NotificationsServiceException");
const se_AssociateChannelCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/channels/associate/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        notificationConfigurationArn: [],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
exports.se_AssociateChannelCommand = se_AssociateChannelCommand;
const se_AssociateManagedNotificationAccountContactCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/contacts/associate-managed-notification/{contactIdentifier}");
    b.p("contactIdentifier", () => input.contactIdentifier, "{contactIdentifier}", false);
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        managedNotificationConfigurationArn: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
exports.se_AssociateManagedNotificationAccountContactCommand = se_AssociateManagedNotificationAccountContactCommand;
const se_AssociateManagedNotificationAdditionalChannelCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/channels/associate-managed-notification/{channelArn}");
    b.p("channelArn", () => input.channelArn, "{channelArn}", false);
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        managedNotificationConfigurationArn: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
exports.se_AssociateManagedNotificationAdditionalChannelCommand = se_AssociateManagedNotificationAdditionalChannelCommand;
const se_CreateEventRuleCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/event-rules");
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        eventPattern: [],
        eventType: [],
        notificationConfigurationArn: [],
        regions: (_) => (0, smithy_client_1._json)(_),
        source: [],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
exports.se_CreateEventRuleCommand = se_CreateEventRuleCommand;
const se_CreateNotificationConfigurationCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/notification-configurations");
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        aggregationDuration: [],
        description: [],
        name: [],
        tags: (_) => (0, smithy_client_1._json)(_),
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
exports.se_CreateNotificationConfigurationCommand = se_CreateNotificationConfigurationCommand;
const se_DeleteEventRuleCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/event-rules/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    b.m("DELETE").h(headers).b(body);
    return b.build();
};
exports.se_DeleteEventRuleCommand = se_DeleteEventRuleCommand;
const se_DeleteNotificationConfigurationCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/notification-configurations/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    b.m("DELETE").h(headers).b(body);
    return b.build();
};
exports.se_DeleteNotificationConfigurationCommand = se_DeleteNotificationConfigurationCommand;
const se_DeregisterNotificationHubCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/notification-hubs/{notificationHubRegion}");
    b.p("notificationHubRegion", () => input.notificationHubRegion, "{notificationHubRegion}", false);
    let body;
    b.m("DELETE").h(headers).b(body);
    return b.build();
};
exports.se_DeregisterNotificationHubCommand = se_DeregisterNotificationHubCommand;
const se_DisableNotificationsAccessForOrganizationCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/organization/access");
    let body;
    b.m("DELETE").h(headers).b(body);
    return b.build();
};
exports.se_DisableNotificationsAccessForOrganizationCommand = se_DisableNotificationsAccessForOrganizationCommand;
const se_DisassociateChannelCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/channels/disassociate/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        notificationConfigurationArn: [],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
exports.se_DisassociateChannelCommand = se_DisassociateChannelCommand;
const se_DisassociateManagedNotificationAccountContactCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/contacts/disassociate-managed-notification/{contactIdentifier}");
    b.p("contactIdentifier", () => input.contactIdentifier, "{contactIdentifier}", false);
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        managedNotificationConfigurationArn: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
exports.se_DisassociateManagedNotificationAccountContactCommand = se_DisassociateManagedNotificationAccountContactCommand;
const se_DisassociateManagedNotificationAdditionalChannelCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/channels/disassociate-managed-notification/{channelArn}");
    b.p("channelArn", () => input.channelArn, "{channelArn}", false);
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        managedNotificationConfigurationArn: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
exports.se_DisassociateManagedNotificationAdditionalChannelCommand = se_DisassociateManagedNotificationAdditionalChannelCommand;
const se_EnableNotificationsAccessForOrganizationCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/organization/access");
    let body;
    b.m("POST").h(headers).b(body);
    return b.build();
};
exports.se_EnableNotificationsAccessForOrganizationCommand = se_EnableNotificationsAccessForOrganizationCommand;
const se_GetEventRuleCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/event-rules/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
exports.se_GetEventRuleCommand = se_GetEventRuleCommand;
const se_GetManagedNotificationChildEventCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/managed-notification-child-events/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    const query = (0, smithy_client_1.map)({
        [_l]: [, input[_l]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
exports.se_GetManagedNotificationChildEventCommand = se_GetManagedNotificationChildEventCommand;
const se_GetManagedNotificationConfigurationCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/managed-notification-configurations/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
exports.se_GetManagedNotificationConfigurationCommand = se_GetManagedNotificationConfigurationCommand;
const se_GetManagedNotificationEventCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/managed-notification-events/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    const query = (0, smithy_client_1.map)({
        [_l]: [, input[_l]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
exports.se_GetManagedNotificationEventCommand = se_GetManagedNotificationEventCommand;
const se_GetNotificationConfigurationCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/notification-configurations/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
exports.se_GetNotificationConfigurationCommand = se_GetNotificationConfigurationCommand;
const se_GetNotificationEventCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/notification-events/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    const query = (0, smithy_client_1.map)({
        [_l]: [, input[_l]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
exports.se_GetNotificationEventCommand = se_GetNotificationEventCommand;
const se_GetNotificationsAccessForOrganizationCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/organization/access");
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
exports.se_GetNotificationsAccessForOrganizationCommand = se_GetNotificationsAccessForOrganizationCommand;
const se_ListChannelsCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/channels");
    const query = (0, smithy_client_1.map)({
        [_nCA]: [, (0, smithy_client_1.expectNonNull)(input[_nCA], `notificationConfigurationArn`)],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
exports.se_ListChannelsCommand = se_ListChannelsCommand;
const se_ListEventRulesCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/event-rules");
    const query = (0, smithy_client_1.map)({
        [_nCA]: [, (0, smithy_client_1.expectNonNull)(input[_nCA], `notificationConfigurationArn`)],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
exports.se_ListEventRulesCommand = se_ListEventRulesCommand;
const se_ListManagedNotificationChannelAssociationsCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/channels/list-managed-notification-channel-associations");
    const query = (0, smithy_client_1.map)({
        [_mNCA]: [, (0, smithy_client_1.expectNonNull)(input[_mNCA], `managedNotificationConfigurationArn`)],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
exports.se_ListManagedNotificationChannelAssociationsCommand = se_ListManagedNotificationChannelAssociationsCommand;
const se_ListManagedNotificationChildEventsCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/list-managed-notification-child-events/{aggregateManagedNotificationEventArn}");
    b.p("aggregateManagedNotificationEventArn", () => input.aggregateManagedNotificationEventArn, "{aggregateManagedNotificationEventArn}", false);
    const query = (0, smithy_client_1.map)({
        [_sT]: [() => input.startTime !== void 0, () => (0, smithy_client_1.serializeDateTime)(input[_sT]).toString()],
        [_eT]: [() => input.endTime !== void 0, () => (0, smithy_client_1.serializeDateTime)(input[_eT]).toString()],
        [_l]: [, input[_l]],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_rA]: [, input[_rA]],
        [_oUI]: [, input[_oUI]],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
exports.se_ListManagedNotificationChildEventsCommand = se_ListManagedNotificationChildEventsCommand;
const se_ListManagedNotificationConfigurationsCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/managed-notification-configurations");
    const query = (0, smithy_client_1.map)({
        [_cI]: [, input[_cI]],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
exports.se_ListManagedNotificationConfigurationsCommand = se_ListManagedNotificationConfigurationsCommand;
const se_ListManagedNotificationEventsCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/managed-notification-events");
    const query = (0, smithy_client_1.map)({
        [_sT]: [() => input.startTime !== void 0, () => (0, smithy_client_1.serializeDateTime)(input[_sT]).toString()],
        [_eT]: [() => input.endTime !== void 0, () => (0, smithy_client_1.serializeDateTime)(input[_eT]).toString()],
        [_l]: [, input[_l]],
        [_s]: [, input[_s]],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
        [_oUI]: [, input[_oUI]],
        [_rA]: [, input[_rA]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
exports.se_ListManagedNotificationEventsCommand = se_ListManagedNotificationEventsCommand;
const se_ListNotificationConfigurationsCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/notification-configurations");
    const query = (0, smithy_client_1.map)({
        [_eRS]: [, input[_eRS]],
        [_cA]: [, input[_cA]],
        [_st]: [, input[_st]],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
exports.se_ListNotificationConfigurationsCommand = se_ListNotificationConfigurationsCommand;
const se_ListNotificationEventsCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/notification-events");
    const query = (0, smithy_client_1.map)({
        [_sT]: [() => input.startTime !== void 0, () => (0, smithy_client_1.serializeDateTime)(input[_sT]).toString()],
        [_eT]: [() => input.endTime !== void 0, () => (0, smithy_client_1.serializeDateTime)(input[_eT]).toString()],
        [_l]: [, input[_l]],
        [_s]: [, input[_s]],
        [_iCE]: [() => input.includeChildEvents !== void 0, () => input[_iCE].toString()],
        [_aNEA]: [, input[_aNEA]],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
exports.se_ListNotificationEventsCommand = se_ListNotificationEventsCommand;
const se_ListNotificationHubsCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/notification-hubs");
    const query = (0, smithy_client_1.map)({
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
exports.se_ListNotificationHubsCommand = se_ListNotificationHubsCommand;
const se_ListTagsForResourceCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/tags/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
exports.se_ListTagsForResourceCommand = se_ListTagsForResourceCommand;
const se_RegisterNotificationHubCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/notification-hubs");
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        notificationHubRegion: [],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
exports.se_RegisterNotificationHubCommand = se_RegisterNotificationHubCommand;
const se_TagResourceCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/tags/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        tags: (_) => (0, smithy_client_1._json)(_),
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
exports.se_TagResourceCommand = se_TagResourceCommand;
const se_UntagResourceCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {};
    b.bp("/tags/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    const query = (0, smithy_client_1.map)({
        [_tK]: [(0, smithy_client_1.expectNonNull)(input.tagKeys, `tagKeys`) != null, () => input[_tK] || []],
    });
    let body;
    b.m("DELETE").h(headers).q(query).b(body);
    return b.build();
};
exports.se_UntagResourceCommand = se_UntagResourceCommand;
const se_UpdateEventRuleCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/event-rules/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        eventPattern: [],
        regions: (_) => (0, smithy_client_1._json)(_),
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
exports.se_UpdateEventRuleCommand = se_UpdateEventRuleCommand;
const se_UpdateNotificationConfigurationCommand = async (input, context) => {
    const b = (0, core_2.requestBuilder)(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/notification-configurations/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        aggregationDuration: [],
        description: [],
        name: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
exports.se_UpdateNotificationConfigurationCommand = se_UpdateNotificationConfigurationCommand;
const de_AssociateChannelCommand = async (output, context) => {
    if (output.statusCode !== 201 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_AssociateChannelCommand = de_AssociateChannelCommand;
const de_AssociateManagedNotificationAccountContactCommand = async (output, context) => {
    if (output.statusCode !== 201 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_AssociateManagedNotificationAccountContactCommand = de_AssociateManagedNotificationAccountContactCommand;
const de_AssociateManagedNotificationAdditionalChannelCommand = async (output, context) => {
    if (output.statusCode !== 201 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_AssociateManagedNotificationAdditionalChannelCommand = de_AssociateManagedNotificationAdditionalChannelCommand;
const de_CreateEventRuleCommand = async (output, context) => {
    if (output.statusCode !== 201 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        arn: smithy_client_1.expectString,
        notificationConfigurationArn: smithy_client_1.expectString,
        statusSummaryByRegion: smithy_client_1._json,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_CreateEventRuleCommand = de_CreateEventRuleCommand;
const de_CreateNotificationConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 201 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        arn: smithy_client_1.expectString,
        status: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_CreateNotificationConfigurationCommand = de_CreateNotificationConfigurationCommand;
const de_DeleteEventRuleCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_DeleteEventRuleCommand = de_DeleteEventRuleCommand;
const de_DeleteNotificationConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_DeleteNotificationConfigurationCommand = de_DeleteNotificationConfigurationCommand;
const de_DeregisterNotificationHubCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        notificationHubRegion: smithy_client_1.expectString,
        statusSummary: smithy_client_1._json,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_DeregisterNotificationHubCommand = de_DeregisterNotificationHubCommand;
const de_DisableNotificationsAccessForOrganizationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_DisableNotificationsAccessForOrganizationCommand = de_DisableNotificationsAccessForOrganizationCommand;
const de_DisassociateChannelCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_DisassociateChannelCommand = de_DisassociateChannelCommand;
const de_DisassociateManagedNotificationAccountContactCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_DisassociateManagedNotificationAccountContactCommand = de_DisassociateManagedNotificationAccountContactCommand;
const de_DisassociateManagedNotificationAdditionalChannelCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_DisassociateManagedNotificationAdditionalChannelCommand = de_DisassociateManagedNotificationAdditionalChannelCommand;
const de_EnableNotificationsAccessForOrganizationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_EnableNotificationsAccessForOrganizationCommand = de_EnableNotificationsAccessForOrganizationCommand;
const de_GetEventRuleCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        arn: smithy_client_1.expectString,
        creationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        eventPattern: smithy_client_1.expectString,
        eventType: smithy_client_1.expectString,
        managedRules: smithy_client_1._json,
        notificationConfigurationArn: smithy_client_1.expectString,
        regions: smithy_client_1._json,
        source: smithy_client_1.expectString,
        statusSummaryByRegion: smithy_client_1._json,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_GetEventRuleCommand = de_GetEventRuleCommand;
const de_GetManagedNotificationChildEventCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        arn: smithy_client_1.expectString,
        content: (_) => de_ManagedNotificationChildEvent(_, context),
        creationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        managedNotificationConfigurationArn: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_GetManagedNotificationChildEventCommand = de_GetManagedNotificationChildEventCommand;
const de_GetManagedNotificationConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        arn: smithy_client_1.expectString,
        category: smithy_client_1.expectString,
        description: smithy_client_1.expectString,
        name: smithy_client_1.expectString,
        subCategory: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_GetManagedNotificationConfigurationCommand = de_GetManagedNotificationConfigurationCommand;
const de_GetManagedNotificationEventCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        arn: smithy_client_1.expectString,
        content: (_) => de_ManagedNotificationEvent(_, context),
        creationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        managedNotificationConfigurationArn: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_GetManagedNotificationEventCommand = de_GetManagedNotificationEventCommand;
const de_GetNotificationConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        aggregationDuration: smithy_client_1.expectString,
        arn: smithy_client_1.expectString,
        creationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        description: smithy_client_1.expectString,
        name: smithy_client_1.expectString,
        status: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_GetNotificationConfigurationCommand = de_GetNotificationConfigurationCommand;
const de_GetNotificationEventCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        arn: smithy_client_1.expectString,
        content: (_) => de_NotificationEventSchema(_, context),
        creationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        notificationConfigurationArn: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_GetNotificationEventCommand = de_GetNotificationEventCommand;
const de_GetNotificationsAccessForOrganizationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        notificationsAccessForOrganization: smithy_client_1._json,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_GetNotificationsAccessForOrganizationCommand = de_GetNotificationsAccessForOrganizationCommand;
const de_ListChannelsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        channels: smithy_client_1._json,
        nextToken: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListChannelsCommand = de_ListChannelsCommand;
const de_ListEventRulesCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        eventRules: (_) => de_EventRules(_, context),
        nextToken: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListEventRulesCommand = de_ListEventRulesCommand;
const de_ListManagedNotificationChannelAssociationsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        channelAssociations: smithy_client_1._json,
        nextToken: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListManagedNotificationChannelAssociationsCommand = de_ListManagedNotificationChannelAssociationsCommand;
const de_ListManagedNotificationChildEventsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        managedNotificationChildEvents: (_) => de_ManagedNotificationChildEvents(_, context),
        nextToken: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListManagedNotificationChildEventsCommand = de_ListManagedNotificationChildEventsCommand;
const de_ListManagedNotificationConfigurationsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        managedNotificationConfigurations: smithy_client_1._json,
        nextToken: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListManagedNotificationConfigurationsCommand = de_ListManagedNotificationConfigurationsCommand;
const de_ListManagedNotificationEventsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        managedNotificationEvents: (_) => de_ManagedNotificationEvents(_, context),
        nextToken: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListManagedNotificationEventsCommand = de_ListManagedNotificationEventsCommand;
const de_ListNotificationConfigurationsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        nextToken: smithy_client_1.expectString,
        notificationConfigurations: (_) => de_NotificationConfigurations(_, context),
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListNotificationConfigurationsCommand = de_ListNotificationConfigurationsCommand;
const de_ListNotificationEventsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        nextToken: smithy_client_1.expectString,
        notificationEvents: (_) => de_NotificationEvents(_, context),
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListNotificationEventsCommand = de_ListNotificationEventsCommand;
const de_ListNotificationHubsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        nextToken: smithy_client_1.expectString,
        notificationHubs: (_) => de_NotificationHubs(_, context),
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListNotificationHubsCommand = de_ListNotificationHubsCommand;
const de_ListTagsForResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        tags: smithy_client_1._json,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListTagsForResourceCommand = de_ListTagsForResourceCommand;
const de_RegisterNotificationHubCommand = async (output, context) => {
    if (output.statusCode !== 201 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        creationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        lastActivationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        notificationHubRegion: smithy_client_1.expectString,
        statusSummary: smithy_client_1._json,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_RegisterNotificationHubCommand = de_RegisterNotificationHubCommand;
const de_TagResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_TagResourceCommand = de_TagResourceCommand;
const de_UntagResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_UntagResourceCommand = de_UntagResourceCommand;
const de_UpdateEventRuleCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        arn: smithy_client_1.expectString,
        notificationConfigurationArn: smithy_client_1.expectString,
        statusSummaryByRegion: smithy_client_1._json,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_UpdateEventRuleCommand = de_UpdateEventRuleCommand;
const de_UpdateNotificationConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await (0, core_1.parseJsonBody)(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        arn: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_UpdateNotificationConfigurationCommand = de_UpdateNotificationConfigurationCommand;
const de_CommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await (0, core_1.parseJsonErrorBody)(output.body, context),
    };
    const errorCode = (0, core_1.loadRestJsonErrorCode)(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.notifications#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.notifications#ConflictException":
            throw await de_ConflictExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.notifications#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.notifications#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.notifications#ServiceQuotaExceededException":
            throw await de_ServiceQuotaExceededExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.notifications#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.notifications#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const throwDefaultError = (0, smithy_client_1.withBaseException)(NotificationsServiceException_1.NotificationsServiceException);
const de_AccessDeniedExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({});
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        message: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.AccessDeniedException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const de_ConflictExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({});
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        message: smithy_client_1.expectString,
        resourceId: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.ConflictException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const de_InternalServerExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({});
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        message: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.InternalServerException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const de_ResourceNotFoundExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({});
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        message: smithy_client_1.expectString,
        resourceId: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.ResourceNotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const de_ServiceQuotaExceededExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({});
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        message: smithy_client_1.expectString,
        quotaCode: smithy_client_1.expectString,
        resourceId: smithy_client_1.expectString,
        resourceType: smithy_client_1.expectString,
        serviceCode: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.ServiceQuotaExceededException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const de_ThrottlingExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({
        [_rAS]: [() => void 0 !== parsedOutput.headers[_ra], () => (0, smithy_client_1.strictParseInt32)(parsedOutput.headers[_ra])],
    });
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        message: smithy_client_1.expectString,
        quotaCode: smithy_client_1.expectString,
        serviceCode: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.ThrottlingException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const de_ValidationExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({});
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        fieldList: smithy_client_1._json,
        message: smithy_client_1.expectString,
        reason: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.ValidationException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const de_EventRules = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_EventRuleStructure(entry, context);
    });
    return retVal;
};
const de_EventRuleStructure = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        arn: smithy_client_1.expectString,
        creationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        eventPattern: smithy_client_1.expectString,
        eventType: smithy_client_1.expectString,
        managedRules: smithy_client_1._json,
        notificationConfigurationArn: smithy_client_1.expectString,
        regions: smithy_client_1._json,
        source: smithy_client_1.expectString,
        statusSummaryByRegion: smithy_client_1._json,
    });
};
const de_ManagedNotificationChildEvent = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        aggregateManagedNotificationEventArn: smithy_client_1.expectString,
        aggregationDetail: smithy_client_1._json,
        endTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        eventStatus: smithy_client_1.expectString,
        id: smithy_client_1.expectString,
        messageComponents: smithy_client_1._json,
        notificationType: smithy_client_1.expectString,
        organizationalUnitId: smithy_client_1.expectString,
        schemaVersion: smithy_client_1.expectString,
        sourceEventDetailUrl: smithy_client_1.expectString,
        sourceEventDetailUrlDisplayText: smithy_client_1.expectString,
        startTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        textParts: smithy_client_1._json,
    });
};
const de_ManagedNotificationChildEventOverview = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        aggregateManagedNotificationEventArn: smithy_client_1.expectString,
        arn: smithy_client_1.expectString,
        childEvent: smithy_client_1._json,
        creationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        managedNotificationConfigurationArn: smithy_client_1.expectString,
        organizationalUnitId: smithy_client_1.expectString,
        relatedAccount: smithy_client_1.expectString,
    });
};
const de_ManagedNotificationChildEvents = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ManagedNotificationChildEventOverview(entry, context);
    });
    return retVal;
};
const de_ManagedNotificationEvent = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        aggregationEventType: smithy_client_1.expectString,
        aggregationSummary: smithy_client_1._json,
        endTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        eventStatus: smithy_client_1.expectString,
        id: smithy_client_1.expectString,
        messageComponents: smithy_client_1._json,
        notificationType: smithy_client_1.expectString,
        organizationalUnitId: smithy_client_1.expectString,
        schemaVersion: smithy_client_1.expectString,
        sourceEventDetailUrl: smithy_client_1.expectString,
        sourceEventDetailUrlDisplayText: smithy_client_1.expectString,
        startTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        textParts: smithy_client_1._json,
    });
};
const de_ManagedNotificationEventOverview = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        aggregatedNotificationRegions: smithy_client_1._json,
        aggregationEventType: smithy_client_1.expectString,
        aggregationSummary: smithy_client_1._json,
        arn: smithy_client_1.expectString,
        creationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        managedNotificationConfigurationArn: smithy_client_1.expectString,
        notificationEvent: smithy_client_1._json,
        organizationalUnitId: smithy_client_1.expectString,
        relatedAccount: smithy_client_1.expectString,
    });
};
const de_ManagedNotificationEvents = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ManagedNotificationEventOverview(entry, context);
    });
    return retVal;
};
const de_NotificationConfigurations = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_NotificationConfigurationStructure(entry, context);
    });
    return retVal;
};
const de_NotificationConfigurationStructure = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        aggregationDuration: smithy_client_1.expectString,
        arn: smithy_client_1.expectString,
        creationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        description: smithy_client_1.expectString,
        name: smithy_client_1.expectString,
        status: smithy_client_1.expectString,
    });
};
const de_NotificationEventOverview = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        aggregateNotificationEventArn: smithy_client_1.expectString,
        aggregationEventType: smithy_client_1.expectString,
        aggregationSummary: smithy_client_1._json,
        arn: smithy_client_1.expectString,
        creationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        notificationConfigurationArn: smithy_client_1.expectString,
        notificationEvent: smithy_client_1._json,
        relatedAccount: smithy_client_1.expectString,
    });
};
const de_NotificationEvents = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_NotificationEventOverview(entry, context);
    });
    return retVal;
};
const de_NotificationEventSchema = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        aggregateNotificationEventArn: smithy_client_1.expectString,
        aggregationEventType: smithy_client_1.expectString,
        aggregationSummary: smithy_client_1._json,
        endTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        eventStatus: smithy_client_1.expectString,
        id: smithy_client_1.expectString,
        media: smithy_client_1._json,
        messageComponents: smithy_client_1._json,
        notificationType: smithy_client_1.expectString,
        schemaVersion: smithy_client_1.expectString,
        sourceEventDetailUrl: smithy_client_1.expectString,
        sourceEventDetailUrlDisplayText: smithy_client_1.expectString,
        sourceEventMetadata: (_) => de_SourceEventMetadata(_, context),
        startTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        textParts: smithy_client_1._json,
    });
};
const de_NotificationHubOverview = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        creationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        lastActivationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        notificationHubRegion: smithy_client_1.expectString,
        statusSummary: smithy_client_1._json,
    });
};
const de_NotificationHubs = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_NotificationHubOverview(entry, context);
    });
    return retVal;
};
const de_SourceEventMetadata = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        eventOccurrenceTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        eventOriginRegion: smithy_client_1.expectString,
        eventType: smithy_client_1.expectString,
        eventTypeVersion: smithy_client_1.expectString,
        relatedAccount: smithy_client_1.expectString,
        relatedResources: smithy_client_1._json,
        source: smithy_client_1.expectString,
        sourceEventId: smithy_client_1.expectString,
    });
};
const deserializeMetadata = (output) => ({
    httpStatusCode: output.statusCode,
    requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
    extendedRequestId: output.headers["x-amz-id-2"],
    cfId: output.headers["x-amz-cf-id"],
});
const collectBodyString = (streamBody, context) => (0, smithy_client_1.collectBody)(streamBody, context).then((body) => context.utf8Encoder(body));
const _aNEA = "aggregateNotificationEventArn";
const _cA = "channelArn";
const _cI = "channelIdentifier";
const _eRS = "eventRuleSource";
const _eT = "endTime";
const _iCE = "includeChildEvents";
const _l = "locale";
const _mNCA = "managedNotificationConfigurationArn";
const _mR = "maxResults";
const _nCA = "notificationConfigurationArn";
const _nT = "nextToken";
const _oUI = "organizationalUnitId";
const _rA = "relatedAccount";
const _rAS = "retryAfterSeconds";
const _ra = "retry-after";
const _s = "source";
const _sT = "startTime";
const _st = "status";
const _tK = "tagKeys";
