import { loadRestJsonErrorCode, parseJsonBody as parseBody, parseJsonErrorBody as parseErrorBody } from "@aws-sdk/core";
import { requestBuilder as rb } from "@smithy/core";
import { _json, collectBody, decorateServiceException as __decorateServiceException, expectNonNull as __expectNonNull, expectObject as __expectObject, expectString as __expectString, map, parseRfc3339DateTimeWithOffset as __parseRfc3339DateTimeWithOffset, serializeDateTime as __serializeDateTime, strictParseInt32 as __strictParseInt32, take, withBaseException, } from "@smithy/smithy-client";
import { AccessDeniedException, ConflictException, InternalServerException, ResourceNotFoundException, ServiceQuotaExceededException, ThrottlingException, ValidationException, } from "../models/models_0";
import { NotificationsServiceException as __BaseException } from "../models/NotificationsServiceException";
export const se_AssociateChannelCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/channels/associate/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    body = JSON.stringify(take(input, {
        notificationConfigurationArn: [],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_AssociateManagedNotificationAccountContactCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/contacts/associate-managed-notification/{contactIdentifier}");
    b.p("contactIdentifier", () => input.contactIdentifier, "{contactIdentifier}", false);
    let body;
    body = JSON.stringify(take(input, {
        managedNotificationConfigurationArn: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const se_AssociateManagedNotificationAdditionalChannelCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/channels/associate-managed-notification/{channelArn}");
    b.p("channelArn", () => input.channelArn, "{channelArn}", false);
    let body;
    body = JSON.stringify(take(input, {
        managedNotificationConfigurationArn: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const se_CreateEventRuleCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/event-rules");
    let body;
    body = JSON.stringify(take(input, {
        eventPattern: [],
        eventType: [],
        notificationConfigurationArn: [],
        regions: (_) => _json(_),
        source: [],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_CreateNotificationConfigurationCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/notification-configurations");
    let body;
    body = JSON.stringify(take(input, {
        aggregationDuration: [],
        description: [],
        name: [],
        tags: (_) => _json(_),
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_DeleteEventRuleCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/event-rules/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    b.m("DELETE").h(headers).b(body);
    return b.build();
};
export const se_DeleteNotificationConfigurationCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/notification-configurations/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    b.m("DELETE").h(headers).b(body);
    return b.build();
};
export const se_DeregisterNotificationHubCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/notification-hubs/{notificationHubRegion}");
    b.p("notificationHubRegion", () => input.notificationHubRegion, "{notificationHubRegion}", false);
    let body;
    b.m("DELETE").h(headers).b(body);
    return b.build();
};
export const se_DisableNotificationsAccessForOrganizationCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/organization/access");
    let body;
    b.m("DELETE").h(headers).b(body);
    return b.build();
};
export const se_DisassociateChannelCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/channels/disassociate/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    body = JSON.stringify(take(input, {
        notificationConfigurationArn: [],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_DisassociateManagedNotificationAccountContactCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/contacts/disassociate-managed-notification/{contactIdentifier}");
    b.p("contactIdentifier", () => input.contactIdentifier, "{contactIdentifier}", false);
    let body;
    body = JSON.stringify(take(input, {
        managedNotificationConfigurationArn: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const se_DisassociateManagedNotificationAdditionalChannelCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/channels/disassociate-managed-notification/{channelArn}");
    b.p("channelArn", () => input.channelArn, "{channelArn}", false);
    let body;
    body = JSON.stringify(take(input, {
        managedNotificationConfigurationArn: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const se_EnableNotificationsAccessForOrganizationCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/organization/access");
    let body;
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_GetEventRuleCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/event-rules/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_GetManagedNotificationChildEventCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/managed-notification-child-events/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    const query = map({
        [_l]: [, input[_l]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_GetManagedNotificationConfigurationCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/managed-notification-configurations/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_GetManagedNotificationEventCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/managed-notification-events/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    const query = map({
        [_l]: [, input[_l]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_GetNotificationConfigurationCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/notification-configurations/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_GetNotificationEventCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/notification-events/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    const query = map({
        [_l]: [, input[_l]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_GetNotificationsAccessForOrganizationCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/organization/access");
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_ListChannelsCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channels");
    const query = map({
        [_nCA]: [, __expectNonNull(input[_nCA], `notificationConfigurationArn`)],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListEventRulesCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/event-rules");
    const query = map({
        [_nCA]: [, __expectNonNull(input[_nCA], `notificationConfigurationArn`)],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListManagedNotificationChannelAssociationsCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channels/list-managed-notification-channel-associations");
    const query = map({
        [_mNCA]: [, __expectNonNull(input[_mNCA], `managedNotificationConfigurationArn`)],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListManagedNotificationChildEventsCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/list-managed-notification-child-events/{aggregateManagedNotificationEventArn}");
    b.p("aggregateManagedNotificationEventArn", () => input.aggregateManagedNotificationEventArn, "{aggregateManagedNotificationEventArn}", false);
    const query = map({
        [_sT]: [() => input.startTime !== void 0, () => __serializeDateTime(input[_sT]).toString()],
        [_eT]: [() => input.endTime !== void 0, () => __serializeDateTime(input[_eT]).toString()],
        [_l]: [, input[_l]],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_rA]: [, input[_rA]],
        [_oUI]: [, input[_oUI]],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListManagedNotificationConfigurationsCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/managed-notification-configurations");
    const query = map({
        [_cI]: [, input[_cI]],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListManagedNotificationEventsCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/managed-notification-events");
    const query = map({
        [_sT]: [() => input.startTime !== void 0, () => __serializeDateTime(input[_sT]).toString()],
        [_eT]: [() => input.endTime !== void 0, () => __serializeDateTime(input[_eT]).toString()],
        [_l]: [, input[_l]],
        [_s]: [, input[_s]],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
        [_oUI]: [, input[_oUI]],
        [_rA]: [, input[_rA]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListNotificationConfigurationsCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/notification-configurations");
    const query = map({
        [_eRS]: [, input[_eRS]],
        [_cA]: [, input[_cA]],
        [_st]: [, input[_st]],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListNotificationEventsCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/notification-events");
    const query = map({
        [_sT]: [() => input.startTime !== void 0, () => __serializeDateTime(input[_sT]).toString()],
        [_eT]: [() => input.endTime !== void 0, () => __serializeDateTime(input[_eT]).toString()],
        [_l]: [, input[_l]],
        [_s]: [, input[_s]],
        [_iCE]: [() => input.includeChildEvents !== void 0, () => input[_iCE].toString()],
        [_aNEA]: [, input[_aNEA]],
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListNotificationHubsCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/notification-hubs");
    const query = map({
        [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
        [_nT]: [, input[_nT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListTagsForResourceCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/tags/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_RegisterNotificationHubCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/notification-hubs");
    let body;
    body = JSON.stringify(take(input, {
        notificationHubRegion: [],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_TagResourceCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/tags/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    body = JSON.stringify(take(input, {
        tags: (_) => _json(_),
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_UntagResourceCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/tags/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    const query = map({
        [_tK]: [__expectNonNull(input.tagKeys, `tagKeys`) != null, () => input[_tK] || []],
    });
    let body;
    b.m("DELETE").h(headers).q(query).b(body);
    return b.build();
};
export const se_UpdateEventRuleCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/event-rules/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    body = JSON.stringify(take(input, {
        eventPattern: [],
        regions: (_) => _json(_),
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const se_UpdateNotificationConfigurationCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/notification-configurations/{arn}");
    b.p("arn", () => input.arn, "{arn}", false);
    let body;
    body = JSON.stringify(take(input, {
        aggregationDuration: [],
        description: [],
        name: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const de_AssociateChannelCommand = async (output, context) => {
    if (output.statusCode !== 201 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_AssociateManagedNotificationAccountContactCommand = async (output, context) => {
    if (output.statusCode !== 201 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_AssociateManagedNotificationAdditionalChannelCommand = async (output, context) => {
    if (output.statusCode !== 201 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_CreateEventRuleCommand = async (output, context) => {
    if (output.statusCode !== 201 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        arn: __expectString,
        notificationConfigurationArn: __expectString,
        statusSummaryByRegion: _json,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_CreateNotificationConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 201 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        arn: __expectString,
        status: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_DeleteEventRuleCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_DeleteNotificationConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_DeregisterNotificationHubCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        notificationHubRegion: __expectString,
        statusSummary: _json,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_DisableNotificationsAccessForOrganizationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_DisassociateChannelCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_DisassociateManagedNotificationAccountContactCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_DisassociateManagedNotificationAdditionalChannelCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_EnableNotificationsAccessForOrganizationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_GetEventRuleCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        arn: __expectString,
        creationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        eventPattern: __expectString,
        eventType: __expectString,
        managedRules: _json,
        notificationConfigurationArn: __expectString,
        regions: _json,
        source: __expectString,
        statusSummaryByRegion: _json,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_GetManagedNotificationChildEventCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        arn: __expectString,
        content: (_) => de_ManagedNotificationChildEvent(_, context),
        creationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        managedNotificationConfigurationArn: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_GetManagedNotificationConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        arn: __expectString,
        category: __expectString,
        description: __expectString,
        name: __expectString,
        subCategory: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_GetManagedNotificationEventCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        arn: __expectString,
        content: (_) => de_ManagedNotificationEvent(_, context),
        creationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        managedNotificationConfigurationArn: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_GetNotificationConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        aggregationDuration: __expectString,
        arn: __expectString,
        creationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        description: __expectString,
        name: __expectString,
        status: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_GetNotificationEventCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        arn: __expectString,
        content: (_) => de_NotificationEventSchema(_, context),
        creationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        notificationConfigurationArn: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_GetNotificationsAccessForOrganizationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        notificationsAccessForOrganization: _json,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListChannelsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        channels: _json,
        nextToken: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListEventRulesCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        eventRules: (_) => de_EventRules(_, context),
        nextToken: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListManagedNotificationChannelAssociationsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        channelAssociations: _json,
        nextToken: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListManagedNotificationChildEventsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        managedNotificationChildEvents: (_) => de_ManagedNotificationChildEvents(_, context),
        nextToken: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListManagedNotificationConfigurationsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        managedNotificationConfigurations: _json,
        nextToken: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListManagedNotificationEventsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        managedNotificationEvents: (_) => de_ManagedNotificationEvents(_, context),
        nextToken: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListNotificationConfigurationsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        nextToken: __expectString,
        notificationConfigurations: (_) => de_NotificationConfigurations(_, context),
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListNotificationEventsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        nextToken: __expectString,
        notificationEvents: (_) => de_NotificationEvents(_, context),
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListNotificationHubsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        nextToken: __expectString,
        notificationHubs: (_) => de_NotificationHubs(_, context),
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListTagsForResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        tags: _json,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_RegisterNotificationHubCommand = async (output, context) => {
    if (output.statusCode !== 201 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        creationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        lastActivationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        notificationHubRegion: __expectString,
        statusSummary: _json,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_TagResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_UntagResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_UpdateEventRuleCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        arn: __expectString,
        notificationConfigurationArn: __expectString,
        statusSummaryByRegion: _json,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_UpdateNotificationConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        arn: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
const de_CommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.notifications#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.notifications#ConflictException":
            throw await de_ConflictExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.notifications#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.notifications#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.notifications#ServiceQuotaExceededException":
            throw await de_ServiceQuotaExceededExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.notifications#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.notifications#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const throwDefaultError = withBaseException(__BaseException);
const de_AccessDeniedExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        message: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new AccessDeniedException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_ConflictExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        message: __expectString,
        resourceId: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new ConflictException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_InternalServerExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        message: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new InternalServerException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_ResourceNotFoundExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        message: __expectString,
        resourceId: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new ResourceNotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_ServiceQuotaExceededExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        message: __expectString,
        quotaCode: __expectString,
        resourceId: __expectString,
        resourceType: __expectString,
        serviceCode: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new ServiceQuotaExceededException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_ThrottlingExceptionRes = async (parsedOutput, context) => {
    const contents = map({
        [_rAS]: [() => void 0 !== parsedOutput.headers[_ra], () => __strictParseInt32(parsedOutput.headers[_ra])],
    });
    const data = parsedOutput.body;
    const doc = take(data, {
        message: __expectString,
        quotaCode: __expectString,
        serviceCode: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new ThrottlingException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_ValidationExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        fieldList: _json,
        message: __expectString,
        reason: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new ValidationException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_EventRules = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_EventRuleStructure(entry, context);
    });
    return retVal;
};
const de_EventRuleStructure = (output, context) => {
    return take(output, {
        arn: __expectString,
        creationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        eventPattern: __expectString,
        eventType: __expectString,
        managedRules: _json,
        notificationConfigurationArn: __expectString,
        regions: _json,
        source: __expectString,
        statusSummaryByRegion: _json,
    });
};
const de_ManagedNotificationChildEvent = (output, context) => {
    return take(output, {
        aggregateManagedNotificationEventArn: __expectString,
        aggregationDetail: _json,
        endTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        eventStatus: __expectString,
        id: __expectString,
        messageComponents: _json,
        notificationType: __expectString,
        organizationalUnitId: __expectString,
        schemaVersion: __expectString,
        sourceEventDetailUrl: __expectString,
        sourceEventDetailUrlDisplayText: __expectString,
        startTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        textParts: _json,
    });
};
const de_ManagedNotificationChildEventOverview = (output, context) => {
    return take(output, {
        aggregateManagedNotificationEventArn: __expectString,
        arn: __expectString,
        childEvent: _json,
        creationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        managedNotificationConfigurationArn: __expectString,
        organizationalUnitId: __expectString,
        relatedAccount: __expectString,
    });
};
const de_ManagedNotificationChildEvents = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ManagedNotificationChildEventOverview(entry, context);
    });
    return retVal;
};
const de_ManagedNotificationEvent = (output, context) => {
    return take(output, {
        aggregationEventType: __expectString,
        aggregationSummary: _json,
        endTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        eventStatus: __expectString,
        id: __expectString,
        messageComponents: _json,
        notificationType: __expectString,
        organizationalUnitId: __expectString,
        schemaVersion: __expectString,
        sourceEventDetailUrl: __expectString,
        sourceEventDetailUrlDisplayText: __expectString,
        startTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        textParts: _json,
    });
};
const de_ManagedNotificationEventOverview = (output, context) => {
    return take(output, {
        aggregatedNotificationRegions: _json,
        aggregationEventType: __expectString,
        aggregationSummary: _json,
        arn: __expectString,
        creationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        managedNotificationConfigurationArn: __expectString,
        notificationEvent: _json,
        organizationalUnitId: __expectString,
        relatedAccount: __expectString,
    });
};
const de_ManagedNotificationEvents = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ManagedNotificationEventOverview(entry, context);
    });
    return retVal;
};
const de_NotificationConfigurations = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_NotificationConfigurationStructure(entry, context);
    });
    return retVal;
};
const de_NotificationConfigurationStructure = (output, context) => {
    return take(output, {
        aggregationDuration: __expectString,
        arn: __expectString,
        creationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        description: __expectString,
        name: __expectString,
        status: __expectString,
    });
};
const de_NotificationEventOverview = (output, context) => {
    return take(output, {
        aggregateNotificationEventArn: __expectString,
        aggregationEventType: __expectString,
        aggregationSummary: _json,
        arn: __expectString,
        creationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        notificationConfigurationArn: __expectString,
        notificationEvent: _json,
        relatedAccount: __expectString,
    });
};
const de_NotificationEvents = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_NotificationEventOverview(entry, context);
    });
    return retVal;
};
const de_NotificationEventSchema = (output, context) => {
    return take(output, {
        aggregateNotificationEventArn: __expectString,
        aggregationEventType: __expectString,
        aggregationSummary: _json,
        endTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        eventStatus: __expectString,
        id: __expectString,
        media: _json,
        messageComponents: _json,
        notificationType: __expectString,
        schemaVersion: __expectString,
        sourceEventDetailUrl: __expectString,
        sourceEventDetailUrlDisplayText: __expectString,
        sourceEventMetadata: (_) => de_SourceEventMetadata(_, context),
        startTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        textParts: _json,
    });
};
const de_NotificationHubOverview = (output, context) => {
    return take(output, {
        creationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        lastActivationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        notificationHubRegion: __expectString,
        statusSummary: _json,
    });
};
const de_NotificationHubs = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_NotificationHubOverview(entry, context);
    });
    return retVal;
};
const de_SourceEventMetadata = (output, context) => {
    return take(output, {
        eventOccurrenceTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        eventOriginRegion: __expectString,
        eventType: __expectString,
        eventTypeVersion: __expectString,
        relatedAccount: __expectString,
        relatedResources: _json,
        source: __expectString,
        sourceEventId: __expectString,
    });
};
const deserializeMetadata = (output) => ({
    httpStatusCode: output.statusCode,
    requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
    extendedRequestId: output.headers["x-amz-id-2"],
    cfId: output.headers["x-amz-cf-id"],
});
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const _aNEA = "aggregateNotificationEventArn";
const _cA = "channelArn";
const _cI = "channelIdentifier";
const _eRS = "eventRuleSource";
const _eT = "endTime";
const _iCE = "includeChildEvents";
const _l = "locale";
const _mNCA = "managedNotificationConfigurationArn";
const _mR = "maxResults";
const _nCA = "notificationConfigurationArn";
const _nT = "nextToken";
const _oUI = "organizationalUnitId";
const _rA = "relatedAccount";
const _rAS = "retryAfterSeconds";
const _ra = "retry-after";
const _s = "source";
const _sT = "startTime";
const _st = "status";
const _tK = "tagKeys";
