import { HttpHandlerOptions as __HttpHandlerOptions } from "@smithy/types";
import {
  AssociateChannelCommandInput,
  AssociateChannelCommandOutput,
} from "./commands/AssociateChannelCommand";
import {
  AssociateManagedNotificationAccountContactCommandInput,
  AssociateManagedNotificationAccountContactCommandOutput,
} from "./commands/AssociateManagedNotificationAccountContactCommand";
import {
  AssociateManagedNotificationAdditionalChannelCommandInput,
  AssociateManagedNotificationAdditionalChannelCommandOutput,
} from "./commands/AssociateManagedNotificationAdditionalChannelCommand";
import {
  CreateEventRuleCommandInput,
  CreateEventRuleCommandOutput,
} from "./commands/CreateEventRuleCommand";
import {
  CreateNotificationConfigurationCommandInput,
  CreateNotificationConfigurationCommandOutput,
} from "./commands/CreateNotificationConfigurationCommand";
import {
  DeleteEventRuleCommandInput,
  DeleteEventRuleCommandOutput,
} from "./commands/DeleteEventRuleCommand";
import {
  DeleteNotificationConfigurationCommandInput,
  DeleteNotificationConfigurationCommandOutput,
} from "./commands/DeleteNotificationConfigurationCommand";
import {
  DeregisterNotificationHubCommandInput,
  DeregisterNotificationHubCommandOutput,
} from "./commands/DeregisterNotificationHubCommand";
import {
  DisableNotificationsAccessForOrganizationCommandInput,
  DisableNotificationsAccessForOrganizationCommandOutput,
} from "./commands/DisableNotificationsAccessForOrganizationCommand";
import {
  DisassociateChannelCommandInput,
  DisassociateChannelCommandOutput,
} from "./commands/DisassociateChannelCommand";
import {
  DisassociateManagedNotificationAccountContactCommandInput,
  DisassociateManagedNotificationAccountContactCommandOutput,
} from "./commands/DisassociateManagedNotificationAccountContactCommand";
import {
  DisassociateManagedNotificationAdditionalChannelCommandInput,
  DisassociateManagedNotificationAdditionalChannelCommandOutput,
} from "./commands/DisassociateManagedNotificationAdditionalChannelCommand";
import {
  EnableNotificationsAccessForOrganizationCommandInput,
  EnableNotificationsAccessForOrganizationCommandOutput,
} from "./commands/EnableNotificationsAccessForOrganizationCommand";
import {
  GetEventRuleCommandInput,
  GetEventRuleCommandOutput,
} from "./commands/GetEventRuleCommand";
import {
  GetManagedNotificationChildEventCommandInput,
  GetManagedNotificationChildEventCommandOutput,
} from "./commands/GetManagedNotificationChildEventCommand";
import {
  GetManagedNotificationConfigurationCommandInput,
  GetManagedNotificationConfigurationCommandOutput,
} from "./commands/GetManagedNotificationConfigurationCommand";
import {
  GetManagedNotificationEventCommandInput,
  GetManagedNotificationEventCommandOutput,
} from "./commands/GetManagedNotificationEventCommand";
import {
  GetNotificationConfigurationCommandInput,
  GetNotificationConfigurationCommandOutput,
} from "./commands/GetNotificationConfigurationCommand";
import {
  GetNotificationEventCommandInput,
  GetNotificationEventCommandOutput,
} from "./commands/GetNotificationEventCommand";
import {
  GetNotificationsAccessForOrganizationCommandInput,
  GetNotificationsAccessForOrganizationCommandOutput,
} from "./commands/GetNotificationsAccessForOrganizationCommand";
import {
  ListChannelsCommandInput,
  ListChannelsCommandOutput,
} from "./commands/ListChannelsCommand";
import {
  ListEventRulesCommandInput,
  ListEventRulesCommandOutput,
} from "./commands/ListEventRulesCommand";
import {
  ListManagedNotificationChannelAssociationsCommandInput,
  ListManagedNotificationChannelAssociationsCommandOutput,
} from "./commands/ListManagedNotificationChannelAssociationsCommand";
import {
  ListManagedNotificationChildEventsCommandInput,
  ListManagedNotificationChildEventsCommandOutput,
} from "./commands/ListManagedNotificationChildEventsCommand";
import {
  ListManagedNotificationConfigurationsCommandInput,
  ListManagedNotificationConfigurationsCommandOutput,
} from "./commands/ListManagedNotificationConfigurationsCommand";
import {
  ListManagedNotificationEventsCommandInput,
  ListManagedNotificationEventsCommandOutput,
} from "./commands/ListManagedNotificationEventsCommand";
import {
  ListNotificationConfigurationsCommandInput,
  ListNotificationConfigurationsCommandOutput,
} from "./commands/ListNotificationConfigurationsCommand";
import {
  ListNotificationEventsCommandInput,
  ListNotificationEventsCommandOutput,
} from "./commands/ListNotificationEventsCommand";
import {
  ListNotificationHubsCommandInput,
  ListNotificationHubsCommandOutput,
} from "./commands/ListNotificationHubsCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "./commands/ListTagsForResourceCommand";
import {
  RegisterNotificationHubCommandInput,
  RegisterNotificationHubCommandOutput,
} from "./commands/RegisterNotificationHubCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "./commands/TagResourceCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "./commands/UntagResourceCommand";
import {
  UpdateEventRuleCommandInput,
  UpdateEventRuleCommandOutput,
} from "./commands/UpdateEventRuleCommand";
import {
  UpdateNotificationConfigurationCommandInput,
  UpdateNotificationConfigurationCommandOutput,
} from "./commands/UpdateNotificationConfigurationCommand";
import { NotificationsClient } from "./NotificationsClient";
export interface Notifications {
  associateChannel(
    args: AssociateChannelCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<AssociateChannelCommandOutput>;
  associateChannel(
    args: AssociateChannelCommandInput,
    cb: (err: any, data?: AssociateChannelCommandOutput) => void
  ): void;
  associateChannel(
    args: AssociateChannelCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: AssociateChannelCommandOutput) => void
  ): void;
  associateManagedNotificationAccountContact(
    args: AssociateManagedNotificationAccountContactCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<AssociateManagedNotificationAccountContactCommandOutput>;
  associateManagedNotificationAccountContact(
    args: AssociateManagedNotificationAccountContactCommandInput,
    cb: (
      err: any,
      data?: AssociateManagedNotificationAccountContactCommandOutput
    ) => void
  ): void;
  associateManagedNotificationAccountContact(
    args: AssociateManagedNotificationAccountContactCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: AssociateManagedNotificationAccountContactCommandOutput
    ) => void
  ): void;
  associateManagedNotificationAdditionalChannel(
    args: AssociateManagedNotificationAdditionalChannelCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<AssociateManagedNotificationAdditionalChannelCommandOutput>;
  associateManagedNotificationAdditionalChannel(
    args: AssociateManagedNotificationAdditionalChannelCommandInput,
    cb: (
      err: any,
      data?: AssociateManagedNotificationAdditionalChannelCommandOutput
    ) => void
  ): void;
  associateManagedNotificationAdditionalChannel(
    args: AssociateManagedNotificationAdditionalChannelCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: AssociateManagedNotificationAdditionalChannelCommandOutput
    ) => void
  ): void;
  createEventRule(
    args: CreateEventRuleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateEventRuleCommandOutput>;
  createEventRule(
    args: CreateEventRuleCommandInput,
    cb: (err: any, data?: CreateEventRuleCommandOutput) => void
  ): void;
  createEventRule(
    args: CreateEventRuleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateEventRuleCommandOutput) => void
  ): void;
  createNotificationConfiguration(
    args: CreateNotificationConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateNotificationConfigurationCommandOutput>;
  createNotificationConfiguration(
    args: CreateNotificationConfigurationCommandInput,
    cb: (err: any, data?: CreateNotificationConfigurationCommandOutput) => void
  ): void;
  createNotificationConfiguration(
    args: CreateNotificationConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateNotificationConfigurationCommandOutput) => void
  ): void;
  deleteEventRule(
    args: DeleteEventRuleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteEventRuleCommandOutput>;
  deleteEventRule(
    args: DeleteEventRuleCommandInput,
    cb: (err: any, data?: DeleteEventRuleCommandOutput) => void
  ): void;
  deleteEventRule(
    args: DeleteEventRuleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteEventRuleCommandOutput) => void
  ): void;
  deleteNotificationConfiguration(
    args: DeleteNotificationConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteNotificationConfigurationCommandOutput>;
  deleteNotificationConfiguration(
    args: DeleteNotificationConfigurationCommandInput,
    cb: (err: any, data?: DeleteNotificationConfigurationCommandOutput) => void
  ): void;
  deleteNotificationConfiguration(
    args: DeleteNotificationConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteNotificationConfigurationCommandOutput) => void
  ): void;
  deregisterNotificationHub(
    args: DeregisterNotificationHubCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeregisterNotificationHubCommandOutput>;
  deregisterNotificationHub(
    args: DeregisterNotificationHubCommandInput,
    cb: (err: any, data?: DeregisterNotificationHubCommandOutput) => void
  ): void;
  deregisterNotificationHub(
    args: DeregisterNotificationHubCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeregisterNotificationHubCommandOutput) => void
  ): void;
  disableNotificationsAccessForOrganization(): Promise<DisableNotificationsAccessForOrganizationCommandOutput>;
  disableNotificationsAccessForOrganization(
    args: DisableNotificationsAccessForOrganizationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DisableNotificationsAccessForOrganizationCommandOutput>;
  disableNotificationsAccessForOrganization(
    args: DisableNotificationsAccessForOrganizationCommandInput,
    cb: (
      err: any,
      data?: DisableNotificationsAccessForOrganizationCommandOutput
    ) => void
  ): void;
  disableNotificationsAccessForOrganization(
    args: DisableNotificationsAccessForOrganizationCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: DisableNotificationsAccessForOrganizationCommandOutput
    ) => void
  ): void;
  disassociateChannel(
    args: DisassociateChannelCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DisassociateChannelCommandOutput>;
  disassociateChannel(
    args: DisassociateChannelCommandInput,
    cb: (err: any, data?: DisassociateChannelCommandOutput) => void
  ): void;
  disassociateChannel(
    args: DisassociateChannelCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DisassociateChannelCommandOutput) => void
  ): void;
  disassociateManagedNotificationAccountContact(
    args: DisassociateManagedNotificationAccountContactCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DisassociateManagedNotificationAccountContactCommandOutput>;
  disassociateManagedNotificationAccountContact(
    args: DisassociateManagedNotificationAccountContactCommandInput,
    cb: (
      err: any,
      data?: DisassociateManagedNotificationAccountContactCommandOutput
    ) => void
  ): void;
  disassociateManagedNotificationAccountContact(
    args: DisassociateManagedNotificationAccountContactCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: DisassociateManagedNotificationAccountContactCommandOutput
    ) => void
  ): void;
  disassociateManagedNotificationAdditionalChannel(
    args: DisassociateManagedNotificationAdditionalChannelCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DisassociateManagedNotificationAdditionalChannelCommandOutput>;
  disassociateManagedNotificationAdditionalChannel(
    args: DisassociateManagedNotificationAdditionalChannelCommandInput,
    cb: (
      err: any,
      data?: DisassociateManagedNotificationAdditionalChannelCommandOutput
    ) => void
  ): void;
  disassociateManagedNotificationAdditionalChannel(
    args: DisassociateManagedNotificationAdditionalChannelCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: DisassociateManagedNotificationAdditionalChannelCommandOutput
    ) => void
  ): void;
  enableNotificationsAccessForOrganization(): Promise<EnableNotificationsAccessForOrganizationCommandOutput>;
  enableNotificationsAccessForOrganization(
    args: EnableNotificationsAccessForOrganizationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<EnableNotificationsAccessForOrganizationCommandOutput>;
  enableNotificationsAccessForOrganization(
    args: EnableNotificationsAccessForOrganizationCommandInput,
    cb: (
      err: any,
      data?: EnableNotificationsAccessForOrganizationCommandOutput
    ) => void
  ): void;
  enableNotificationsAccessForOrganization(
    args: EnableNotificationsAccessForOrganizationCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: EnableNotificationsAccessForOrganizationCommandOutput
    ) => void
  ): void;
  getEventRule(
    args: GetEventRuleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetEventRuleCommandOutput>;
  getEventRule(
    args: GetEventRuleCommandInput,
    cb: (err: any, data?: GetEventRuleCommandOutput) => void
  ): void;
  getEventRule(
    args: GetEventRuleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetEventRuleCommandOutput) => void
  ): void;
  getManagedNotificationChildEvent(
    args: GetManagedNotificationChildEventCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetManagedNotificationChildEventCommandOutput>;
  getManagedNotificationChildEvent(
    args: GetManagedNotificationChildEventCommandInput,
    cb: (err: any, data?: GetManagedNotificationChildEventCommandOutput) => void
  ): void;
  getManagedNotificationChildEvent(
    args: GetManagedNotificationChildEventCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetManagedNotificationChildEventCommandOutput) => void
  ): void;
  getManagedNotificationConfiguration(
    args: GetManagedNotificationConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetManagedNotificationConfigurationCommandOutput>;
  getManagedNotificationConfiguration(
    args: GetManagedNotificationConfigurationCommandInput,
    cb: (
      err: any,
      data?: GetManagedNotificationConfigurationCommandOutput
    ) => void
  ): void;
  getManagedNotificationConfiguration(
    args: GetManagedNotificationConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: GetManagedNotificationConfigurationCommandOutput
    ) => void
  ): void;
  getManagedNotificationEvent(
    args: GetManagedNotificationEventCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetManagedNotificationEventCommandOutput>;
  getManagedNotificationEvent(
    args: GetManagedNotificationEventCommandInput,
    cb: (err: any, data?: GetManagedNotificationEventCommandOutput) => void
  ): void;
  getManagedNotificationEvent(
    args: GetManagedNotificationEventCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetManagedNotificationEventCommandOutput) => void
  ): void;
  getNotificationConfiguration(
    args: GetNotificationConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetNotificationConfigurationCommandOutput>;
  getNotificationConfiguration(
    args: GetNotificationConfigurationCommandInput,
    cb: (err: any, data?: GetNotificationConfigurationCommandOutput) => void
  ): void;
  getNotificationConfiguration(
    args: GetNotificationConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetNotificationConfigurationCommandOutput) => void
  ): void;
  getNotificationEvent(
    args: GetNotificationEventCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetNotificationEventCommandOutput>;
  getNotificationEvent(
    args: GetNotificationEventCommandInput,
    cb: (err: any, data?: GetNotificationEventCommandOutput) => void
  ): void;
  getNotificationEvent(
    args: GetNotificationEventCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetNotificationEventCommandOutput) => void
  ): void;
  getNotificationsAccessForOrganization(): Promise<GetNotificationsAccessForOrganizationCommandOutput>;
  getNotificationsAccessForOrganization(
    args: GetNotificationsAccessForOrganizationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetNotificationsAccessForOrganizationCommandOutput>;
  getNotificationsAccessForOrganization(
    args: GetNotificationsAccessForOrganizationCommandInput,
    cb: (
      err: any,
      data?: GetNotificationsAccessForOrganizationCommandOutput
    ) => void
  ): void;
  getNotificationsAccessForOrganization(
    args: GetNotificationsAccessForOrganizationCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: GetNotificationsAccessForOrganizationCommandOutput
    ) => void
  ): void;
  listChannels(
    args: ListChannelsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListChannelsCommandOutput>;
  listChannels(
    args: ListChannelsCommandInput,
    cb: (err: any, data?: ListChannelsCommandOutput) => void
  ): void;
  listChannels(
    args: ListChannelsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListChannelsCommandOutput) => void
  ): void;
  listEventRules(
    args: ListEventRulesCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListEventRulesCommandOutput>;
  listEventRules(
    args: ListEventRulesCommandInput,
    cb: (err: any, data?: ListEventRulesCommandOutput) => void
  ): void;
  listEventRules(
    args: ListEventRulesCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListEventRulesCommandOutput) => void
  ): void;
  listManagedNotificationChannelAssociations(
    args: ListManagedNotificationChannelAssociationsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListManagedNotificationChannelAssociationsCommandOutput>;
  listManagedNotificationChannelAssociations(
    args: ListManagedNotificationChannelAssociationsCommandInput,
    cb: (
      err: any,
      data?: ListManagedNotificationChannelAssociationsCommandOutput
    ) => void
  ): void;
  listManagedNotificationChannelAssociations(
    args: ListManagedNotificationChannelAssociationsCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: ListManagedNotificationChannelAssociationsCommandOutput
    ) => void
  ): void;
  listManagedNotificationChildEvents(
    args: ListManagedNotificationChildEventsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListManagedNotificationChildEventsCommandOutput>;
  listManagedNotificationChildEvents(
    args: ListManagedNotificationChildEventsCommandInput,
    cb: (
      err: any,
      data?: ListManagedNotificationChildEventsCommandOutput
    ) => void
  ): void;
  listManagedNotificationChildEvents(
    args: ListManagedNotificationChildEventsCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: ListManagedNotificationChildEventsCommandOutput
    ) => void
  ): void;
  listManagedNotificationConfigurations(): Promise<ListManagedNotificationConfigurationsCommandOutput>;
  listManagedNotificationConfigurations(
    args: ListManagedNotificationConfigurationsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListManagedNotificationConfigurationsCommandOutput>;
  listManagedNotificationConfigurations(
    args: ListManagedNotificationConfigurationsCommandInput,
    cb: (
      err: any,
      data?: ListManagedNotificationConfigurationsCommandOutput
    ) => void
  ): void;
  listManagedNotificationConfigurations(
    args: ListManagedNotificationConfigurationsCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: ListManagedNotificationConfigurationsCommandOutput
    ) => void
  ): void;
  listManagedNotificationEvents(): Promise<ListManagedNotificationEventsCommandOutput>;
  listManagedNotificationEvents(
    args: ListManagedNotificationEventsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListManagedNotificationEventsCommandOutput>;
  listManagedNotificationEvents(
    args: ListManagedNotificationEventsCommandInput,
    cb: (err: any, data?: ListManagedNotificationEventsCommandOutput) => void
  ): void;
  listManagedNotificationEvents(
    args: ListManagedNotificationEventsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListManagedNotificationEventsCommandOutput) => void
  ): void;
  listNotificationConfigurations(): Promise<ListNotificationConfigurationsCommandOutput>;
  listNotificationConfigurations(
    args: ListNotificationConfigurationsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListNotificationConfigurationsCommandOutput>;
  listNotificationConfigurations(
    args: ListNotificationConfigurationsCommandInput,
    cb: (err: any, data?: ListNotificationConfigurationsCommandOutput) => void
  ): void;
  listNotificationConfigurations(
    args: ListNotificationConfigurationsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListNotificationConfigurationsCommandOutput) => void
  ): void;
  listNotificationEvents(): Promise<ListNotificationEventsCommandOutput>;
  listNotificationEvents(
    args: ListNotificationEventsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListNotificationEventsCommandOutput>;
  listNotificationEvents(
    args: ListNotificationEventsCommandInput,
    cb: (err: any, data?: ListNotificationEventsCommandOutput) => void
  ): void;
  listNotificationEvents(
    args: ListNotificationEventsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListNotificationEventsCommandOutput) => void
  ): void;
  listNotificationHubs(): Promise<ListNotificationHubsCommandOutput>;
  listNotificationHubs(
    args: ListNotificationHubsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListNotificationHubsCommandOutput>;
  listNotificationHubs(
    args: ListNotificationHubsCommandInput,
    cb: (err: any, data?: ListNotificationHubsCommandOutput) => void
  ): void;
  listNotificationHubs(
    args: ListNotificationHubsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListNotificationHubsCommandOutput) => void
  ): void;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListTagsForResourceCommandOutput>;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    cb: (err: any, data?: ListTagsForResourceCommandOutput) => void
  ): void;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListTagsForResourceCommandOutput) => void
  ): void;
  registerNotificationHub(
    args: RegisterNotificationHubCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<RegisterNotificationHubCommandOutput>;
  registerNotificationHub(
    args: RegisterNotificationHubCommandInput,
    cb: (err: any, data?: RegisterNotificationHubCommandOutput) => void
  ): void;
  registerNotificationHub(
    args: RegisterNotificationHubCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: RegisterNotificationHubCommandOutput) => void
  ): void;
  tagResource(
    args: TagResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<TagResourceCommandOutput>;
  tagResource(
    args: TagResourceCommandInput,
    cb: (err: any, data?: TagResourceCommandOutput) => void
  ): void;
  tagResource(
    args: TagResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: TagResourceCommandOutput) => void
  ): void;
  untagResource(
    args: UntagResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UntagResourceCommandOutput>;
  untagResource(
    args: UntagResourceCommandInput,
    cb: (err: any, data?: UntagResourceCommandOutput) => void
  ): void;
  untagResource(
    args: UntagResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UntagResourceCommandOutput) => void
  ): void;
  updateEventRule(
    args: UpdateEventRuleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateEventRuleCommandOutput>;
  updateEventRule(
    args: UpdateEventRuleCommandInput,
    cb: (err: any, data?: UpdateEventRuleCommandOutput) => void
  ): void;
  updateEventRule(
    args: UpdateEventRuleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateEventRuleCommandOutput) => void
  ): void;
  updateNotificationConfiguration(
    args: UpdateNotificationConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateNotificationConfigurationCommandOutput>;
  updateNotificationConfiguration(
    args: UpdateNotificationConfigurationCommandInput,
    cb: (err: any, data?: UpdateNotificationConfigurationCommandOutput) => void
  ): void;
  updateNotificationConfiguration(
    args: UpdateNotificationConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateNotificationConfigurationCommandOutput) => void
  ): void;
}
export declare class Notifications
  extends NotificationsClient
  implements Notifications {}
